Index: cpp/tests/part_shapes.goal
===================================================================
--- cpp/tests/part_shapes.goal	(revision 1009)
+++ cpp/tests/part_shapes.goal	(revision 1034)
@@ -1,21 +1,21 @@
 //0s
 p:sh=1, sy=0.7, sz=0.4
-p:1.0, sh=1, sx=0.9, sy=0.63, sz=0.36000000000000004, rx=0.10000000000000003, 0.19999999999999998, 0.29999999999999993
-p:1.8426640272257795, 0.260666529862964, 0.1788023977155551, sh=1, sx=0.81, sy=0.5670000000000001, sz=0.32400000000000007, rx=0.13808669019769443, 0.42035825292871176, 0.5983443807960972
-p:2.453676692193477, 0.6771993843888386, 0.50935330809034, sh=1, sx=0.7290000000000001, sy=0.5103000000000001, sz=0.2916000000000001, rx=0.09931899168188495, 0.6411696655688546, 0.9281320894976495
-p:2.8038163494411, 1.144867119871271, 0.9453924228624562, sh=1, sx=0.6561000000000001, sy=0.45927000000000007, sz=0.26244000000000006, rx=-0.0508678834140355, 0.8352605372405658, 1.3398264106880768
-p:2.9045952639659256, 1.5734096003943585, 1.4318717777936978, sh=1, sx=0.5904900000000002, sy=0.41334300000000007, sz=0.23619600000000007, rx=-0.35230461258336737, 0.9570308312423439, 1.8863978754398574
-p:2.7990344836199674, 1.8967049535832903, 1.9145885439819008, sh=1, sx=0.5314410000000002, sy=0.3720087000000001, sz=0.21257640000000008, rx=-0.7405336877073184, 0.9531453201489807, 2.5147044296432366
-p:2.549785601507846, 2.077250744420876, 2.3478410669493828, sh=1, sx=0.47829690000000014, sy=0.3348078300000001, sz=0.1913187600000001, rx=-1.0334725042183834, 0.8257581906137964, 3.0533851341586113
-p:2.2267611218154277, 2.1058180609178136, 2.6994189651415414, sh=1, sx=0.43046721000000016, sy=0.30132704700000007, sz=0.1721868840000001, rx=-1.1761487722698027, 0.6291781757493043, -2.824331705531365
-p:1.8960928227086258, 1.9972423634866159, 2.952740525176071, sh=1, sx=0.38742048900000015, sy=0.27119434230000006, sz=0.15496819560000008, rx=-1.209905083954168, 0.4077881373309235, -2.497457349984353
-p:1.6117065276381082, 1.783670701302811, 3.106383668808028, sh=1, sx=0.34867844010000015, sy=0.24407490807000007, sz=0.13947137604000007, rx=-1.1680909122962837, 0.18806847422834463, -2.1997658329492182
+p:1.0, sh=1, sx=0.9, sy=0.63, sz=0.36000000000000004, rx=0.09999999999999999, 0.2, 0.3
+p:1.8426640272257795, 0.260666529862964, 0.1788023977155551, sh=1, sx=0.81, sy=0.5670000000000001, sz=0.32400000000000007, rx=0.1380866901976944, 0.4203582529287118, 0.5983443807960972
+p:2.453676692193477, 0.6771993843888386, 0.50935330809034, sh=1, sx=0.7290000000000001, sy=0.5103000000000001, sz=0.2916000000000001, rx=0.09931899168188486, 0.6411696655688547, 0.9281320894976496
+p:2.8038163494411, 1.144867119871271, 0.9453924228624563, sh=1, sx=0.6561000000000001, sy=0.45927000000000007, sz=0.26244000000000006, rx=-0.050867883414035614, 0.8352605372405658, 1.339826410688077
+p:2.9045952639659256, 1.5734096003943587, 1.431871777793698, sh=1, sx=0.5904900000000002, sy=0.41334300000000007, sz=0.23619600000000007, rx=-0.35230461258336765, 0.9570308312423438, 1.8863978754398578
+p:2.799034483619967, 1.8967049535832905, 1.9145885439819013, sh=1, sx=0.5314410000000002, sy=0.3720087000000001, sz=0.21257640000000008, rx=-0.7405336877073186, 0.9531453201489805, 2.514704429643237
+p:2.5497856015078453, 2.0772507444208763, 2.3478410669493837, sh=1, sx=0.47829690000000014, sy=0.3348078300000001, sz=0.1913187600000001, rx=-1.0334725042183832, 0.8257581906137962, 3.0533851341586113
+p:2.2267611218154264, 2.105818060917814, 2.699418965141543, sh=1, sx=0.43046721000000016, sy=0.30132704700000007, sz=0.1721868840000001, rx=-1.1761487722698027, 0.6291781757493042, -2.824331705531365
+p:1.8960928227086242, 1.9972423634866163, 2.9527405251760723, sh=1, sx=0.38742048900000015, sy=0.27119434230000006, sz=0.15496819560000008, rx=-1.209905083954168, 0.4077881373309235, -2.4974573499843524
+p:1.6117065276381064, 1.7836707013028112, 3.1063836688080295, sh=1, sx=0.34867844010000015, sy=0.24407490807000007, sz=0.13947137604000007, rx=-1.1680909122962837, 0.18806847422834477, -2.1997658329492182
 p:0.04894345998764038, z=0.30901700258255005, sh=3, sx=0.3128689344768277, sy=0.05, sz=0.05, rx=-1.546024634805094, 1.41371677309148
 p:0.23992645740509033, z=0.8968022465705872, sh=3, sx=0.3128689224093409, sy=0.05, sz=0.05, rx=-1.343474826195397, 1.0995573606273648
 p:0.6031977534294128, z=1.3968022465705872, sh=3, sx=0.3128689534320107, sy=0.05, sz=0.05, rx=-0.9553166181245092, 0.7853981633974483
-p:1.1031978130340576, z=1.7600735425949097, sh=3, sx=0.3128689755174676, sy=0.05, sz=0.05, rx=-0.5194665743234458, 0.4712388796778248
+p:1.1031978130340576, z=1.7600735425949097, sh=3, sx=0.3128689755174676, sy=0.05, sz=0.05, rx=-0.5194665743234458, 0.47123887967782474
 p:1.6909830570220947, z=1.9510565400123596, sh=3, sx=0.3128688756060144, sy=0.05, sz=0.05, rx=-0.15900495985476545, 0.15707958350572937
-p:2.309017062187195, z=1.9510564804077148, sh=3, sx=0.31286900267186113, sy=0.05, sz=0.05, rx=0.15900509312057215, -0.15707971206553287
-p:2.896802306175232, z=1.760073482990265, sh=3, sx=0.3128688422412704, sy=0.05, sz=0.05, rx=0.5194665784785317, -0.47123888291162425
+p:2.309017062187195, z=1.9510564804077148, sh=3, sx=0.31286900267186113, sy=0.05, sz=0.05, rx=0.15900509312057218, -0.15707971206553287
+p:2.896802306175232, z=1.760073482990265, sh=3, sx=0.3128688422412704, sy=0.05, sz=0.05, rx=0.5194665784785317, -0.4712388829116243
 p:3.3968021869659424, z=1.3968023657798767, sh=3, sx=0.31286882699146806, sy=0.05, sz=0.05, rx=0.9553164276144905, -0.7853980286865252
 p:3.76007342338562, z=0.8968026340007782, sh=3, sx=0.3128687896390344, sy=0.05, sz=0.05, rx=1.3434746156488504, -1.0995571444029681